"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("antd-mobile/lib/modal/style");

var _modal = _interopRequireDefault(require("antd-mobile/lib/modal"));

require("antd-mobile/lib/list/style");

var _list = _interopRequireDefault(require("antd-mobile/lib/list"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _closest = _interopRequireDefault(require("../_util/closest"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Item = _list["default"].Item;
var prefixCls = 'eh-select-organization';

var SelectOrganization = /*#__PURE__*/function (_ref) {
  _inherits(SelectOrganization, _ref);

  var _super = _createSuper(SelectOrganization);

  function SelectOrganization() {
    var _this;

    _classCallCheck(this, SelectOrganization);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {});

    _defineProperty(_assertThisInitialized(_this), "onWrapTouchStart", function (e) {
      // fix touch to scroll background page on iOS
      if (!/iPhone|iPod|iPad/i.test(navigator.userAgent)) {
        return;
      }

      var pNode = (0, _closest["default"])(e.target, '.am-modal-content');

      if (!pNode) {
        e.preventDefault();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onClose", function () {
      var onClose = _this.props.onClose;

      if (onClose) {
        onClose();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onSelect", function (org) {
      var _this$props = _this.props,
          onClose = _this$props.onClose,
          onSelect = _this$props.onSelect;

      if (onSelect) {
        onSelect(org);
      }

      if (onClose) {
        onClose();
      }
    });

    return _this;
  }

  _createClass(SelectOrganization, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          visible = _this$props2.visible,
          dataList = _this$props2.dataList,
          nameKey = _this$props2.nameKey,
          valueKey = _this$props2.valueKey,
          title = _this$props2.title;

      if (!visible) {
        return null;
      }

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: prefixCls
      }, /*#__PURE__*/_react["default"].createElement(_modal["default"], {
        visible: visible,
        transparent: true,
        maskClosable: false,
        onClose: this.onClose,
        title: title,
        footer: [{
          text: '取消',
          onPress: function onPress() {
            return _this2.onClose();
          }
        }],
        wrapProps: {
          onTouchStart: this.onWrapTouchStart
        },
        className: prefixCls
      }, /*#__PURE__*/_react["default"].createElement(_list["default"], null, dataList.map(function (org) {
        return /*#__PURE__*/_react["default"].createElement(Item, {
          key: org[valueKey],
          onClick: function onClick() {
            return _this2.onSelect(org);
          }
        }, org[nameKey] || '');
      }))));
    }
  }]);

  return SelectOrganization;
}(_react.PureComponent || _react.Component);

SelectOrganization.propTypes = {
  visible: _propTypes["default"].bool,
  dataList: _propTypes["default"].arrayOf(_propTypes["default"].object),
  title: _propTypes["default"].string,
  onClose: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  // name 的 key 值，决定从数据中获取哪个字段作为 name，默认为 name
  nameKey: _propTypes["default"].string,
  // value 的 key 值，决定从数据中获取哪个字段作为 value，默认为 id
  valueKey: _propTypes["default"].string
};
SelectOrganization.defaultProps = {
  visible: false,
  dataList: [],
  title: '请选择企业',
  nameKey: 'name',
  valueKey: 'id'
};
var _default = SelectOrganization;
exports["default"] = _default;
module.exports = exports.default;